<?php 
      
    // Plugin Page
    $vwbc_options = '';
    $vwbc_options = get_option('vwbc_options');

    /**
    * For Register Custom Menu page in dashboard 
    */
    add_action( 'admin_menu', 'vwbc_register_custom_menu_page' );

    function vwbc_register_custom_menu_page() {

        add_menu_page('VW Breadcrumb', 'VW Breadcrumb', 'add_users', 'vw-breadcrumb', 'vwbc_about_render', null, 6);

        add_action( 'admin_init', 'vwbc_register_settings' );
    }

    //call register settings function
    function vwbc_register_settings() {

      register_setting('vwbc-plugin-option', 'vwbc_options', 'vwbc_validate_options');
    }

function vwbc_about_render(){

    global $title;   global $vwbc_options;?>

    <div id="vwbc_dashboard">

        <div class="vwbc_title">
            <h1>
                <img src="<?php echo esc_attr( VWBC_DIR_URL . 'assets/images/logo.png'); ?>"><?php echo esc_html($title); ?>
               <span class="vwpl-version"><?php echo esc_html('Version ', 'vw-breadcrumb'); ?><?php echo esc_attr( VWBC_VERSION  ) ?></span>
            </h1>
        </div>

        <div class="row m-0">
            <div class="col-md-8 main_box">
                <form method="post" action="options.php">
                    <?php settings_fields( 'vwbc-plugin-option' ); ?>
                    <div class="tab-wrapper">
                        <ul class="product-info-tab-links">
                            <li><a href="#" class="active" data-product-info-link="1"><i class="fa fa-cogs" aria-hidden="true"></i><?php echo esc_html('General Options','breadcrumb'); ?></a></li>
                            <li><a href="#" data-product-info-link="2"><i class="fa fa-pencil-square-o" aria-hidden="true"></i><?php echo esc_html('Style Option','breadcrumb'); ?></a></li>
                            <li><a href="#" data-product-info-link="3"><i class="fa fa-code" aria-hidden="true"></i><?php echo esc_html('Shortcodes','breadcrumb'); ?></a></li>
                        </ul>
                        <div class="product-info-tab" data-product-info-tab="1" style="display: block;">
                        <div class="row">
                            <h4 class="col-md-4"><?php echo esc_html('Home Text', 'vw-breadcrumb'); ?></h4>
                            <div class="col-md-8">
                                <input type="text" name="vwbc_options[vwbc_home_text]" value="<?php echo $vwbc_options['vwbc_home_text']; ?>" /> 
                            </div>
                            
                        </div>
                        <div class="row"> 
                            <h4 class="col-md-4"><label><?php echo esc_html('Home Icon','vw-breadcrumb'); ?></label></h4>
                            <div class="col-md-8">
                                 <input type="text" class="vwbc-home-icon" name="vwbc_options[vwbc_home_font_icon]" placeholder="fa fa-home" value="<?php echo esc_attr($vwbc_options['vwbc_home_font_icon']); ?>" />
                                <p class="note"><?php esc_html_e('(Choose any Font Awesome Icon)', 'vw-breadcrumb'); ?></p>
                                <span class="input-group-addon"></span>
                            </div>
                           
                        </div>
                        <div class="row"> 
                            <h4 class="col-md-4"><label><?php echo esc_html('Breadcrumb Separator','vw-breadcrumb'); ?></label></h4>
                             <div class="col-md-8">
                                 <input type="text" class="vwbc-home-icon" name="vwbc_options[vwbc_home_separator_icon]" placeholder="fa-angle-double-right" value="<?php echo esc_attr($vwbc_options['vwbc_home_separator_icon']); ?>" />
                                
                                <p class="note"><?php esc_html_e('(Choose any Font Awesome Icon)', 'vw-breadcrumb'); ?></p>
                                <span class="input-group-addon"></span>
                            </div>
                        </div>
                        <div class="row"> 
                            <h4 class="col-md-4"><label><?php echo esc_html('Ending Character','vw-breadcrumb'); ?></label></h4>
                            <div class="col-md-8">
                                 <input type="text" name="vwbc_options[vwbc_end_character_icon]" value="<?php echo $vwbc_options['vwbc_end_character_icon']; ?>" maxlength="3" />
                            <label class="note"><?php esc_html_e('(Up to 3 Characters)   ', 'vw-breadcrumb'); ?></label>
                            </div>
                           
                        </div>
                        </div>
                        <div class="product-info-tab" data-product-info-tab="2">
                        <div class="row">
                            <div class="col-md-4">
                                <h4><?php echo esc_html('Text Color', 'vw-breadcrumb'); ?></h4>
                            </div>
                            <div class="bg_input">
                                <input class="color-field" type="text" name="vwbc_options[vwpl_text_color]" value="<?php echo $vwbc_options['vwpl_text_color']; ?>" />
                            </div>
                        </div>
              
                        <div class="row">
                            <div class="col-md-4">
                                <h4><?php echo esc_html('Background Color', 'vw-breadcrumb'); ?></h4>
                            </div>
                            <div class="bg_input">
                                <input class="color-field" type="text" name="vwbc_options[vwpl_background_color]" value="<?php echo $vwbc_options['vwpl_background_color']; ?>" />
                            </div>
                        </div>

                         <div class="row">
                            <div class="col-md-4">
                                <h4><?php echo esc_html('Icon Color', 'vw-breadcrumb'); ?></h4>
                            </div>
                            <div class="bg_input">
                                <input class="color-field" type="text" name="vwbc_options[vwpl_separator_color]" value="<?php echo $vwbc_options['vwpl_separator_color']; ?>" />
                            </div>
                        </div>
                       

                        <div class="row">
                            <div class="col-md-4">
                                <h4><?php echo esc_html('Active Link Color', 'vw-breadcrumb'); ?></h4>
                            </div>
                            <div class="bg_input">
                                <input class="color-field" type="text" name="vwbc_options[vwpl_link_color]" value="<?php echo $vwbc_options['vwpl_link_color']; ?>" />
                            </div>
                        </div>


                        <div class="row">
                            <div class="col-md-4">
                                <h4><?php echo esc_html('Hover Color', 'vw-breadcrumb'); ?></h4>
                            </div>
                            <div class="bg_input">
                                <input class="color-field" type="text" name="vwbc_options[vwpl_hover_color]" value="<?php echo $vwbc_options['vwpl_hover_color']; ?>" />
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-md-4">
                                <h4><?php echo esc_html('Font Size (px)', 'vw-breadcrumb'); ?></h4>
                            </div>
                            <div>
                                <input name="vwbc_options[vwbc_font_size]" class="slider" type="range" min="1" max="100" id="vwbc_font_size" data-show-value="true" value="<?php echo $vwbc_options['vwbc_font_size']; ?>" class="small-text"  />
                                 <span  class="slider_label"></span>  
                            </div>
                        </div>
                 
                      </div>
                      <div class="product-info-tab" data-product-info-tab="3">

                        <div class="short_con">
                            <h3><?php echo _e('Shortcode for content :-','vw-breadcrumb'); ?></h3>
                            <p class=""><?php echo _e('Shortcode inside content anywhere inside content.','vw-breadcrumb'); ?></p>     
                            <code>[vw-breadcrumb]</code>
                            <pre></pre>
                        </div>

                        <div class="short_con">
                            <h3><?php echo _e('Shortcode for php file :-','vw-breadcrumb'); ?></h3>
                            <p class=""><?php echo _e('Shortcode inside .php files for themes.','vw-breadcrumb'); ?></p>
                            
                            <code>&#60;?php echo do_shortcode( '&#91;vw-breadcrumb&#93;' );?&#62;</code>
                            <pre></pre>

                        </div>
                    
                      </div>
                    </div>
                <?php submit_button(); ?>
                </form>
            </div>

            <div class="col-md-4">

                <div class="rate_us_box">

                    <h2><?php echo esc_html('Rate us on wordpress.org', 'vw-breadcrumb'); ?></h2>

                    <p class="thank_msg"><?php echo esc_html('If you enjoy the plugin please rate us', 'vw-breadcrumb'); ?></p>

                    <div class="star_dash">

                      <?php for($i = 0; $i<5; $i++ ){ ?>
                        <img src="<?php echo esc_attr( VWBC_DIR_URL . 'assets/images/star.png'); ?>">
                      <?php } ?>

                    </div>

                    <p class="thank_btn"><a href="https://www.vwthemes.com/topic/reviews-and-testimonials/" target="_blank"><?php echo esc_html('Click Here', 'vw-breadcrumb'); ?></a></p>

                    <p><?php echo esc_html('If you face obstacle, do write at plugins support forum ', 'vw-breadcrumb'); ?><a href="https://www.vwthemes.com/support/" target="_blank"><?php echo esc_html('click here', 'vw-breadcrumb'); ?></a>
                    </p>
                </div>
            </div>
        </div>
    </div>

    <?php 
}

function vwbc_validate_options($input) {

    // Background Color
    if (!isset($input['vwpl_background_color'])){
        $input['vwpl_background_color']     = null;
    } 
    else{
        $input['vwpl_background_color']     = esc_attr($input['vwpl_background_color']);
    }

    // Text Color
    if (!isset($input['vwpl_text_color'])){
        $input['vwpl_text_color']     = null;
    } 
    else{
        $input['vwpl_text_color']     = esc_attr($input['vwpl_text_color']);
    }

    // Separator Color
    if (!isset($input['vwpl_separator_color'])){
        $input['vwpl_separator_color']     = null;
    } 
    else{
        $input['vwpl_separator_color']     = esc_attr($input['vwpl_separator_color']);
    }

    // Link Color
    if (!isset($input['vwpl_link_color'])){
        $input['vwpl_link_color']     = null;
    } 
    else{
        $input['vwpl_link_color']     = esc_attr($input['vwpl_link_color']);
    }

    // Font Size
    if (!isset($input['vwbc_font_size'])){
        $input['vwbc_font_size']     = null;
    } 
    else{
        $input['vwbc_font_size']     = esc_attr($input['vwbc_font_size']);
    }

    // Home Text
    if (!isset($input['vwbc_home_text'])){
        $input['vwbc_home_text']     = null;
    } 
    else{
        $input['vwbc_home_text']     = esc_attr($input['vwbc_home_text']);
    }

    // Home Font Icon
    if (!isset($input['vwbc_home_font_icon'])){
        $input['vwbc_home_font_icon']     = null;
    } 
    else{
        $input['vwbc_home_font_icon']     = esc_attr($input['vwbc_home_font_icon']);
    }

    // Separator Font Icon
    if (!isset($input['vwbc_home_separator_icon'])){
        $input['vwbc_home_separator_icon']     = null;
    } 
    else{
        $input['vwbc_home_separator_icon']     = esc_attr($input['vwbc_home_separator_icon']);
    }

    // Separator Font Icon
    if (!isset($input['vwbc_end_character_icon'])){
        $input['vwbc_end_character_icon']     = null;
    } 
    else{
        $input['vwbc_end_character_icon']     = esc_attr($input['vwbc_end_character_icon']);
    }

    // Hover Color
    if (!isset($input['vwpl_hover_color'])){
        $input['vwpl_hover_color']     = null;
    } 
    else{
        $input['vwpl_hover_color']     = esc_attr($input['vwpl_hover_color']);
    }

    return $input;
}