<?php
/*
 Plugin Name: VW Breadcrumb
 Plugin URI: https://www.vwthemes.com/
 Description: Use to create and display breadcrumb
 Author: VW Themes
 Version: 1.0
 Author URI: https://www.vwthemes.com/
*/

if (!defined('ABSPATH')) {
    exit; //Exit if accessed directly
}

define( 'VWBC_VERSION', '1.0' );

define( 'VWBC_REQUIRED_WP_VERSION', '5.2.2' );

if ( ! defined( 'VWBC_DIR_URL' ) )
    define( 'VWBC_DIR_URL', plugin_dir_url( __FILE__ ) );

// Loading Translation
if ( ! function_exists ( 'vwbc_plugins_loaded' ) ) {

	function vwbc_plugins_loaded() {
		/* Internationalization */
		load_plugin_textdomain( 'vw-breadcrumb', false, VWBC_DIR_URL . '/languages/' );
	}
}

/*Enqueue Admin Setting Files */
require_once( plugin_dir_path( __FILE__ ).'admin/vwbc-admin-settings.php');

/* Enqueue Shortcodes Files */
require_once( plugin_dir_path( __FILE__ ).'vwbc-shortcodes.php');

/* Plugin Style And Script */
add_action( 'wp_enqueue_scripts', 'vwbc_style_scripts' );

function vwbc_style_scripts() {

    // Style for front page section
    wp_enqueue_style( 'vwbc-style', VWBC_DIR_URL . 'assets/css/vwbc-style.css');

    //Fontawesome Style
    wp_enqueue_style( 'fontawesome', VWBC_DIR_URL . 'assets/css/font-awesome/css/font-awesome.css');
}

// Color Picker
add_action( 'admin_enqueue_scripts', 'vwbc_color_picker' );

function vwbc_color_picker( $hook ) {
    
 	// Style for dashboard section
 	wp_enqueue_style( 'vwbc-admin-style', VWBC_DIR_URL . 'assets/css/vwbc-admin-style.css');

    // Add the color picker css and js file       
    wp_enqueue_style( 'wp-color-picker' ); 
    wp_enqueue_script( 'wp-color-picker' ); 
     
    //Fontawesome Icon Picker Style & Script
    wp_enqueue_style( 'fontawesome-iconpicker', VWBC_DIR_URL . 'assets/css/fontawesome-iconpicker.css');
    wp_enqueue_script( 'fontawesome-iconpicker-js', VWBC_DIR_URL . 'assets/js/fontawesome-iconpicker.js');

    //Fontawesome Style
    wp_enqueue_style( 'font-awesome', VWBC_DIR_URL . 'assets/css/font-awesome/css/font-awesome.css');

    // Include our custom jQuery file with WordPress Color Picker dependency
     wp_enqueue_script( 'dynamic-fields-js', VWBC_DIR_URL . 'assets/js/dynamic-fields.js', array( 'jquery' ) ); 
}

